package borland.samples.tutorial.dataset.calccolumn;

import java.awt.*;
import java.awt.event.*;
import borland.jbcl.control.*;
import borland.jbcl.layout.*;
import borland.jbcl.dataset.*;
import borland.jbcl.util.*;   // add this import statement
import java.math.BigDecimal;


public class CalcColumnFrame1 extends DecoratedFrame {
  BorderLayout borderLayout1 = new BorderLayout();
  BevelPanel bevelPanel1 = new BevelPanel();
  NavigatorControl navigatorControl1 = new NavigatorControl();
  Database database1 = new Database();
  QueryDataSet queryDataSet1 = new QueryDataSet();
  GridControl gridControl1 = new GridControl();
  Column column1 = new Column();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
 

  //Construct the frame
  public CalcColumnFrame1() {
    try {
      jbInit();
    }
    catch (Exception e) {
      borland.jbcl.util.Diagnostic.printStackTrace(e);
    };
  }

  //Component initialization
  public void jbInit() throws Exception{
    this.setLayout(borderLayout1);
    this.setTitle("Calculated Columns Example");
    bevelPanel1.setLayout(gridBagLayout1);
    navigatorControl1.setLabels(new String[] {"First", "Prior", "Next", "Last", "Insert", "Delete", "Post", "Cancel", "Ditto", "Save", "Refresh"});
    database1.setConnection(new borland.jbcl.dataset.ConnectionDescriptor("jdbc:odbc:dataset tutorial", "sysdba", "masterkey", false, "sun.jdbc.odbc.JdbcOdbcDriver;borland.interclient.Driver"));
    queryDataSet1.setQuery(new borland.jbcl.dataset.QueryDescriptor(database1, "select * from employee", null, true, false));
    queryDataSet1.addCalcFieldsListener(new CalcColumnFrame1_queryDataSet1_calcFieldsAdapter(this));
    gridControl1.setDataSet(queryDataSet1);
    column1.setAlignment(borland.jbcl.util.Alignment.LEFT | borland.jbcl.util.Alignment.TOP);
    column1.setCalcType(borland.jbcl.dataset.CalcType.CALC);
    column1.setCaption("NEW_SALARY");
    column1.setColumnName("NEW_SALARY");
    column1.setDataType(borland.jbcl.util.Variant.BIGDECIMAL);
    column1.setDisplayMask("");
    column1.setEditMask("");
    column1.setExportDisplayMask("");
    this.add(bevelPanel1, BorderLayout.CENTER);
    bevelPanel1.add(navigatorControl1, new GridBagConstraints2(0, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(10, 7, 0, 0), -9, 9));
    bevelPanel1.add(gridControl1, new GridBagConstraints2(0, 1, 2, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(28, 40, 10, 7), -1316, -666));
    queryDataSet1.setColumns(new Column[] {column1});
  }

  
  void queryDataSet1_calcFields(ReadRow readRow, DataRow dataRow, boolean boolean1)
    throws DataSetException
  {
    dataRow.setBigDecimal("New_Salary", readRow.getBigDecimal("SALARY").multiply(new BigDecimal(1.1)));
  }
}

class CalcColumnFrame1_queryDataSet1_calcFieldsAdapter implements borland.jbcl.dataset.CalcFieldsListener {
  CalcColumnFrame1 adaptee;

  CalcColumnFrame1_queryDataSet1_calcFieldsAdapter(CalcColumnFrame1 adaptee) {
    this.adaptee = adaptee;
  }

  public void calcFields(ReadRow readRow, DataRow dataRow, boolean boolean1)
    throws DataSetException
  {
    adaptee.queryDataSet1_calcFields(readRow, dataRow, boolean1);
  }
}

