package borland.samples.apps.chess.client;

import borland.samples.apps.chess.client.board.*;

/**helper class for the ChessRules class
*/
public class KingPos
{
  private int kingRank = -1;
  private int kingFile = -1;
  private int kingCheckCount = 0;
  private int attacker = -1;
  private int attackerFile = -1;
  private int attackerRank = -1;
  private int kingColor;

  public KingPos(int color) {
    if (color == Chessboard.WHITEPIECE)
      kingColor = Chessboard.WHITEPIECE ;
    else
      kingColor = Chessboard.BLACKPIECE;
  }

  public int getKingColor() {
    return kingColor;
  }

  public boolean KingPosEquals(int file,int rank){
    if (rank == kingRank && file == kingFile)
      return true;
    else
      return false;
  }

  public void SetKingPos(int file,int rank) {
    if (rank >= 0)
      kingRank = rank;
    if (file >= 0)
      kingFile = file;
  //System.out.println("King Pos = " + file + rank + " (" + kingColor);
  }

  public void SetAttacker(int piecevalue,int file,int rank){
    if (piecevalue  < 0) {
      System.out.println("no attacker");
      attacker = -1;
      attackerRank = -1;
      attackerFile = -1;
      kingCheckCount = 0;
    }
    else {
      System.out.println("found attacker" + piecevalue + file + rank);
      attacker = piecevalue;
      attackerRank = rank;
      attackerFile = file;
      kingCheckCount++;
    }
  }

  public int GetKingFile(){
    return kingFile;
  }

  public int GetKingRank(){
    return kingRank;
  }

  public int GetAttacker() {
   return attacker;
  }

  public int GetAttackerFile() {
    return attackerFile;
  }

  public int GetAttackerRank() {
    return attackerRank;
  }

  public void KingInCheck(boolean b) {
    if (b)
      kingCheckCount++;
    else {
      // System.out.println("no attacker");
      attacker = -1;
      attackerRank = -1;
      attackerFile = -1;
      kingCheckCount = 0;
    }
  }

  public boolean isDoubleCheck() {
    return (kingCheckCount > 1)  ;
  }

  public boolean isInCheck () {
    return (kingCheckCount != 0);
  }
}
