package borland.samples.intl.beans;

import java.beans.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import borland.jbcl.model.*;

public abstract class LocaleChooserLocaleSelector extends PropertyEditorSupport implements GraphSelectionListener {

  protected LocaleChooser localeChooser = null;
  protected ResourceBundle resourceBundle = ResourceBundle.getBundle("borland.samples.intl.beans.resources.LocaleChooserRes");

  public LocaleChooserLocaleSelector() {
    localeChooser = new LocaleChooser();
    localeChooser.setAcceptLeafNodesOnly(false);
    localeChooser.setDisplayStyle(LocaleChooser.TARGET_LOCALE);
    localeChooser.addSelectionListener(this);
    localeChooser.setTitle(resourceBundle.getString("Select_a_locale"));
  }

  public abstract String getJavaInitializationString();

  public abstract void setValue(Object o);

  public abstract Object getValue();

  public abstract String getAsText();

  public void setAsText(String text) throws IllegalArgumentException {
    throw new IllegalArgumentException(text);
  }

  public boolean supportsCustomEditor() {
    return true;
  }

  public Component getCustomEditor() {
    return localeChooser;
  }

  public void selectionItemChanged(GraphSelectionEvent e) {
    firePropertyChange();
  }

  public void selectionChanged(GraphSelectionEvent e) {
    firePropertyChange();
  }

}
